<?php 
class Page
{//类定义开始

    /**
     +----------------------------------------------------------
     * 分页起始行数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $firstRow	;

    /**
     +----------------------------------------------------------
     * 列表每页显示行数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $listRows	;

    /**
     +----------------------------------------------------------
     * 页数跳转时要带的参数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $parameter  ;

    /**
     +----------------------------------------------------------
     * 分页总页面数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $totalPages  ;

    /**
     +----------------------------------------------------------
     * 总行数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $totalRows  ;

    /**
     +----------------------------------------------------------
     * 当前页数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $nowPage    ;

    /**
     +----------------------------------------------------------
     * 分页的栏的总页数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $coolPages   ;

    /**
     +----------------------------------------------------------
     * 分页栏每页显示的页数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
    public $rollPage=10   ;
    
    /**
     +----------------------------------------------------------
     * 分页记录名称
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */

	// 分页显示定制
    protected $config   =	array('prev'=>'&lsaquo;','next'=>'&rsaquo;','first'=>'1 ...','last'=>'');

	 /**
     +----------------------------------------------------------
     * ajax分页函数
     +----------------------------------------------------------
     * @var integer
     * @access protected
     +----------------------------------------------------------
     */
	public $var_page='page';
    public $ajaxFunc =""   ;

    /**
     +----------------------------------------------------------
     * 架构函数
     +----------------------------------------------------------
     * @access public 
     +----------------------------------------------------------
     * @param array $totalRows  总的记录数
     * @param array $firstRow  起始记录位置
     * @param array $listRows  每页显示记录数
     * @param array $parameter  分页跳转的参数
     +----------------------------------------------------------
     */
    public function __construct($totalRows,$listRows='',$ajaxFunc="",$parameter='')
    {    
        $this->totalRows = $totalRows;
        $this->parameter = $parameter;
 
        $this->listRows = $listRows;
        $this->totalPages = ceil($this->totalRows/$this->listRows);     //总页数
        $this->coolPages  = ceil($this->totalPages/$this->rollPage);
		$this->nowPage  = !empty($_GET[$this->var_page])&&($_GET[$this->var_page] >0)?$_GET[$this->var_page]:1;
		$this->setConfig('last','... '.$this->totalPages);
		$this->ajaxFunc=$ajaxFunc;

        if(!empty($this->totalPages) && $this->nowPage>$this->totalPages) {
            $this->nowPage = $this->totalPages;
        }
        $this->firstRow = $this->listRows*($this->nowPage-1);
    }

	
	public function setConfig($name,$value) {
		if(isset($this->config[$name])) {
			$this->config[$name]	=	$value;
		}
	}

	public function getHref($page)
	{
		if(empty($this->ajaxFunc)){
			
			$url  =  $_SERVER['REQUEST_URI'];
			if(strpos($_SERVER['REQUEST_URI'],"?")!==false && strpos($_SERVER['REQUEST_URI'],"&")!==false){
				$url=str_replace('&'.$this->var_page.'='.$_GET[$this->var_page],'',$url);
				$href=$url."&".$this->var_page."=".$page;
			}else{
				$url=str_replace('/'.$this->var_page.'/'.$_GET[$this->var_page],'',$url);
				$href=$url."/".$this->var_page."/".$page;
			}
		}else{
			$href="javascript:".$this->ajaxFunc."(".$page.");";
		}
		return $href;
	}

	
	public function show3()
	{
		

		$html=" 共<b>$this->totalPages</b>页 /  当前第<b>$this->nowPage</b>页 ";
	
		if(empty($this->ajaxFunc)){
            $url  =  $_SERVER['REQUEST_URI'];
			if(strpos($_SERVER['REQUEST_URI'],"?")!==false && strpos($_SERVER['REQUEST_URI'],"&")!==false){
				$url=str_replace('&'.$this->var_page.'='.$_GET[$this->var_page],'',$url);
				$href=$url."&".$this->var_page."=";
			}else{
				$url=str_replace('/'.$this->var_page.'/'.$_GET[$this->var_page],'',$url);
				$href=$url."/".$this->var_page."/";
			}
			//$url  =  $_SERVER['REQUEST_URI'];
			//$url=str_replace('/'.$this->var_page.'/'.$_GET[$this->var_page],'',$url);
			$html.="<select name='topage' size='1'  id='input2' onchange='window.location.href=this.options[this.selectedIndex].value'>";
			for($i=1;$i<=$this->totalPages;$i++){
				if($this->nowPage==$i){
					$html.="<option value='".$href.$i."' selected>$i</option>";
				}else{
					$html.="<option value='".$href.$i."' >$i</option>";
				}
			}
			$html.="</select>";

		}else{
			$html.="<select name='topage' size='1'  id='input2' onchange='{$this->ajaxFunc}(this.value)'>";
			for($i=1;$i<=$this->totalPages;$i++){
				if($this->nowPage==$i){
					$html.="<option value='$i' selected>$i</option>";
				}else{
					$html.="<option value='$i' >$i</option>";
				}
			}
			$html.="</select>";
		}
		
		return $html;
	}

	public function show2()
	{
		
		if($this->nowPage==1){
			$html.='<a href="'.$this->getHref($this->nowPage).'">上一页</a> ';
		}else{
			$html.='<a href="'.$this->getHref($this->nowPage-1).'">上一页</a> ';
		}
		
		if($this->nowPage==$this->totalPages){
			$html.='<a href="'.$this->getHref($this->nowPage).'">下一页</a> ';
		}else{
			$html.='<a href="'.$this->getHref($this->nowPage+1).'">下一页</a> ';
		}
		$html.=" 共<b>$this->totalPages</b>页 /  当前第<b>$this->nowPage</b>页 ";
	
		if(empty($this->ajaxFunc)){
			$url  =  $_SERVER['REQUEST_URI'];
			if(strpos($_SERVER['REQUEST_URI'],"?")!==false && strpos($_SERVER['REQUEST_URI'],"&")!==false){
				$url=str_replace('&'.$this->var_page.'='.$_GET[$this->var_page],'',$url);
				$href=$url."&".$this->var_page."=";
			}else{
				$url=str_replace('/'.$this->var_page.'/'.$_GET[$this->var_page],'',$url);
				$href=$url."/".$this->var_page."/";
			}
			$html.="<select name='topage' size='1'  id='input2' onchange='window.location.href=this.options[this.selectedIndex].value'>";
			for($i=1;$i<=$this->totalPages;$i++){
				if($this->nowPage==$i){
					$html.="<option value='".$href.$i."' selected>$i</option>";
				}else{
					$html.="<option value='".$href.$i."' >$i</option>";
				}
			}
			$html.="</select>";

		}else{
			$html.="<select name='topage' size='1'  id='input2' onchange='{$this->ajaxFunc}(this.value)'>";
			for($i=1;$i<=$this->totalPages;$i++){
				if($this->nowPage==$i){
					$html.="<option value='$i' selected>$i</option>";
				}else{
					$html.="<option value='$i' >$i</option>";
				}
			}
			$html.="</select>";
		}
		
		return $html;
	}

    /**
     +----------------------------------------------------------
     * 分页显示
     * 用于在页面显示的分页栏的输出
     +----------------------------------------------------------
     * @access public 
     +----------------------------------------------------------
     * @return string
     +----------------------------------------------------------
     */

    public function show($isArray=false){
        if(0 == $this->totalRows) return " ";
		if($this->totalRows <= $this->listRows)  return " ";
        $nowCoolPage      = ceil($this->nowPage/$this->rollPage);
		//$url  =  $_SERVER['REQUEST_URI'].(strpos($_SERVER['REQUEST_URI'],'?')?'':"?").$this->parameter;
		
        //上下翻页字符串
        $upRow   = $this->nowPage-1;
        $downRow = $this->nowPage+1;

	
        if ($upRow>0){
            $upPage="<a href='".$this->getHref($upRow)."'>".$this->config['prev']."</a>";
        }else{
            $upPage="<span class=\"disabled\">".$this->config['prev']."</span>";
        }

        if ($downRow <= $this->totalPages){
            $downPage="<a href='".$this->getHref($downRow)."'>".$this->config['next']."</a>";
        }else{
            $downPage="<span class=\"disabled\">".$this->config['next']."</span>";
        }
        // << < > >>
        if($nowCoolPage == 1){
            $theFirst = "";
            $prePage = "";
        }else{
            $preRow =  $this->nowPage-$this->rollPage;
            $prePage = "<a href='".$this->getHref($preRow)."' >上".$this->rollPage."页</a>";
            $theFirst = "<a href='".$this->getHref(1)."' class='first' >".$this->config['first']."</a>";
        }
        if($nowCoolPage == $this->coolPages){
            $nextPage = "";
            $theEnd="";
        }else{
            $nextRow = $this->nowPage+$this->rollPage;
            $theEndRow = $this->totalPages;
            $nextPage = "[<a href='".$this->getHref($nextRow)."' >下".$this->rollPage."页</a>]";
            $theEnd = "<a href='".$this->getHref($theEndRow)."' class='last' >".$this->config['last']."</a>";
        }
        // 1 2 3 4 5
        $linkPage = "";
        for($i=1;$i<=$this->rollPage;$i++){
            $page=($nowCoolPage-1)*$this->rollPage+$i;
            if($page!=$this->nowPage){
                if($page<=$this->totalPages){
                    $linkPage .= "<a href='".$this->getHref($page)."'>".$page."</a>";
                }else{
                    break;
                }
            }else{
                if($this->totalPages != 1){
                    $linkPage .= "<span class='current'>".$page."</span>";
                }
            }
        }
        $pageStr = $theFirst.$upPage.$linkPage.$downPage.$theEnd; 
		
        if($isArray) {
            $pageArray['totalRows'] =   $this->totalRows;
            $pageArray['upPage']    =   $this->getHref($upRow);
            $pageArray['downPage']  =   $this->getHref($downRow);
            $pageArray['totalPages']=   $this->totalPages;
            $pageArray['firstPage'] =   $this->getHref(1);
            $pageArray['endPage']   =   $this->getHref($theEndRow);
            $pageArray['nextPages'] =   $this->getHref($nextRow);
            $pageArray['prePages']  =   $this->getHref($preRow);
            $pageArray['linkPages'] =   $linkPage;
			$pageArray['nowPage'] =   $this->nowPage;
        	return $pageArray;
        }
        return $pageStr;
    }

}//类定义结束
?>